	.data
msgBCodif: .asciiz "Codificando el siguinete programa:\n\n"
########## Aca va el programa que voy a codificar!!! ##############
programa:	.asciiz "   .text
main:
   lui $s0 65535
   ori $s0 $s0 65535

   slt $a0 $s0 $0    
   ori $v0 $0 1
   syscall

   slti $a0 $s0 0    
   ori $v0 $0 1
   syscall

   sltu $a0 $s0 $0    
   ori $v0 $0 1
   syscall

   sltiu $a0 $s0 0    
   ori $v0 $0 1
   syscall

   ori $v0 $0 10
   syscall"
########## Aca Termina el Programa ############
msgFCodif: .asciiz "\n\nFinaliza la codificacion...\n\nEjecutando el programa codificado...\n"
	.align 2
data:	.space 200
stack:	.space 200
	.text
text:	.space 400	# Reservo espacio para almacenar el programa compilado (100 instrucciones)
main:
   la $a0 msgBCodif	# imprimo el programa que voy a ensamblar
   jal print_str
   la $a0 programa
   jal print_str
   la $a0 msgFCodif
   jal print_str

   la $a0 programa	# llamo a la funcion con sus respectivos argumentos
   la $a1 text
   la $a2 data
   la $a3 stack
   jal ensamblador

   jr $v0		# una vez compilado lo ejecuto
   j exit		# solo por si acaso ;)


print_str:
   li $v0 4
   syscall
   jr $ra

exit:
   li $v0 10
   syscall

###################################################
########### FIN DEL MAIN ##########################
###################################################

###################################################
######### Comienza la Funcion Ensamblador #########
###################################################

.data		# palabras reservadas (instrucciones)
str_data:	.asciiz ".data"
str_text:	.asciiz ".text"

str_sltiu:      .asciiz "sltiu"
str_addiu:	.asciiz "addiu"
str_slti:       .asciiz "slti"
str_andi:       .asciiz "andi"
str_ori:	.asciiz "ori"
str_addi:	.asciiz "addi"
str_addu:	.asciiz "addu"
str_subu:	.asciiz "subu"
str_multu:      .asciiz "multu" 
str_divu:       .asciiz "divu" 
str_sltu:       .asciiz "sltu"
str_neg:        .asciiz "neg" 
str_mul:        .asciiz "mul"

str_add:	.asciiz "add"
str_sub:	.asciiz "sub"
str_or: 	.asciiz "or"
str_and: 	.asciiz "and"
str_lui:        .asciiz "lui"
str_li:         .asciiz "li" 
str_mult:       .asciiz "mult"  
str_div:        .asciiz "div" 
str_mflo:       .asciiz "mflo"
str_mfhi:       .asciiz "mfhi"
str_sllv:       .asciiz "sllv"
str_sll:        .asciiz "sll"
str_srl:        .asciiz "srl"
str_srlv:       .asciiz "srlv"
str_slt:        .asciiz "slt"
str_lw:         .asciiz "lw"
str_sw:         .asciiz "sw"
str_syscall:	.asciiz "syscall"

.text
###################################################
############ funcion ensamblador ##################
###################################################

ensamblador:
# Entrada, almaceno variables a utilizar
   addi $sp $sp -40
   sw $a1 36($sp)
   sw $ra 32($sp)
   sw $s7 28($sp)
   sw $s6 24($sp)
   sw $s5 20($sp)
   sw $s4 16($sp)
   sw $s3 12($sp)
   sw $s2  8($sp)
   sw $s1  4($sp)
   sw $s0  0($sp)

# Transfiero los argumentos a un lugar seguro
   move $s0 $a0	# s0 -> codigo fuente
   move $s1 $a1	# s1 -> area de .text
   move $s2 $a2	# s2 -> area de .data
   move $s3 $a3	# s3 -> area de stack
   li   $s4 ' '	# s4 -> caracter espacio
   li   $s5 '\n'   # s5 -> caracter "\n" -> EOL
   
# Cuerpo
# asumo que empieza en modo .text
asm_text_loop:
   lb $t0 0($s0)
   addi $s0 $s0 1
   beq $t0 $0 asm_exit		# si ya llegue al fin de archivo me salgo
   beq $t0 $s4 asm_text_loop	# ignoro espacios en blanco
   beq $t0 $s5 asm_text_loop	# y lineas en blanco
   j asm_get_instruction

asm_data_loop:			# nada aun
   j asm_exit

asm_error:			# manejo generico de errores
   la $a0 errMsg		# en caso de cualquier problema, imprimo error
   jal print_str
   j asm_exit

# Salida
asm_exit:
   lw $a1 36($sp)
   lw $ra 32($sp)
   lw $s7 28($sp)
   lw $s6 24($sp)
   lw $s5 20($sp)
   lw $s4 16($sp)
   lw $s3 12($sp)
   lw $s2  8($sp)
   lw $s1  4($sp)
   lw $s0  0($sp)

   move $v0 $a1			# hago trampa para devolver el buffer ;)
   addi $sp $sp 40
   jr $ra

###########################################
###### Funciones ##########################
###########################################

asm_get_instruction:		# este es un gran switch, me indica que instruccion es
   addi $s0 $s0 -1		# chapuz pq ya le habia sumado 1

   move $a0 $s0			# verifico si es la directiva .data
   la $a1 str_data
   jal strcmp
   bne $v0 $0 asm_data_loop
   
   move $a0 $s0			# verifico si es la directiva .text
   la $a1 str_text
   jal strcmp
   bne $v0 $0 asm_text_loop

   move $a0 $s0			# verifico si es la instruccion addiu
   la $a1 str_addiu
   jal strcmp
   li $s7 0x09
   bne $v0 $0 asm_universali

   move $a0 $s0			# verifico si es la instruccion addi
   la $a1 str_addi
   jal strcmp
   li $s7 0x08
   bne $v0 $0 asm_universali

   move $a0 $s0			# verifico si es la instruccion addu
   la $a1 str_addu
   jal strcmp
   li $s7 0x21
   bne $v0 $0 asm_universal

   move $a0 $s0			# verifico si es la instruccion add
   la $a1 str_add
   jal strcmp
   li $s7 0x20
   bne $v0 $0 asm_universal

   move $a0 $s0			# verifico si es la instruccion ori
   la $a1 str_ori
   jal strcmp
   li $s7 0x0d
   bne $v0 $0 asm_universali

   move $a0 $s0			# verifico si es la instruccion or
   la $a1 str_or
   jal strcmp
   li $s7 0x25
   bne $v0 $0 asm_universal

   move $a0 $s0			# verifico si es la instruccion subu
   la $a1 str_subu
   jal strcmp
   li $s7 0x23
   bne $v0 $0 asm_universal

   move $a0 $s0			# verifico si es la instruccion sub
   la $a1 str_sub
   jal strcmp
   li $s7 0x22
   bne $v0 $0 asm_universal

   move $a0 $s0			# verifico si es la instruccion neg
   la $a1 str_neg
   jal strcmp
   li $s7 0x20
   bne $v0 $0 asm_universal7

   move $a0 $s0			# verifico si es la instruccion divu
   la $a1 str_divu
   jal strcmp
   li $s7 0x1b
   bne $v0 $0 asm_universal2

   move $a0 $s0			# verifico si es la instruccion div
   la $a1 str_div
   jal strcmp
   li $s7 0x1a
   bne $v0 $0 asm_verificar

   move $a0 $s0			# verifico si es la instruccion multu
   la $a1 str_multu
   jal strcmp
   li $s7 0x19
   bne $v0 $0 asm_universal2 

   move $a0 $s0			# verifico si es la instruccion mult
   la $a1 str_mult
   jal strcmp
   li $s7 0x18
   bne $v0 $0 asm_universal2

   move $a0 $s0			# verifico si es la instruccion mul
   la $a1 str_mul
   jal strcmp
   li $s7 0x18
   bne $v0 $0 asm_universal8

   move $a0 $s0			# verifico si es la instruccion andi
   la $a1 str_andi
   jal strcmp
   li $s7 0xc	
   bne $v0 $0 asm_universali

   move $a0 $s0			# verifico si es la instruccion and
   la $a1 str_and
   jal strcmp
   li $s7 0x24
   bne $v0 $0 asm_universal

   move $a0 $s0			# verifico si es la instruccion stliu
   la $a1 str_sltiu
   jal strcmp
   li $s7 0x0b
   bne $v0 $0 asm_universali
   
   move $a0 $s0			# verifico si es la instruccion stli
   la $a1 str_slti
   jal strcmp
   li $s7 0xa
   bne $v0 $0 asm_universali
 
   move $a0 $s0			# verifico si es la instruccion sltu
   la $a1 str_sltu
   jal strcmp
   li $s7 0x2b
   bne $v0 $0 asm_universal

   move $a0 $s0			# verifico si es la instruccion slt
   la $a1 str_slt
   jal strcmp
   li $s7 0x2a
   bne $v0 $0 asm_universal

   move $a0 $s0			# verifico si es la instruccion sllv
   la $a1 str_sllv
   jal strcmp
   li $s7 0x04
   bne $v0 $0 asm_universal3

   move $a0 $s0			# verifico si es la instruccion srlv
   la $a1 str_srlv
   jal strcmp
   li $s7 0x06
   bne $v0 $0 asm_universal3
   
   move $a0 $s0			# verifico si es la instruccion sll
   la $a1 str_sll
   jal strcmp
   li $s7 0x00
   bne $v0 $0 asm_universal4   	

   move $a0 $s0			# verifico si es la instruccion srl
   la $a1 str_srl
   jal strcmp
   li $s7 0x02
   bne $v0 $0 asm_universal4 

   move $a0 $s0			# verifico si es la instruccion mflo
   la $a1 str_mflo
   jal strcmp
   li $s7 0x12
   bne $v0 $0 asm_universal5 

   move $a0 $s0			# verifico si es la instruccion mfhi
   la $a1 str_mfhi
   jal strcmp
   li $s7 0x10
   bne $v0 $0 asm_universal5 

   move $a0 $s0			# verifico si es la instruccion lui
   la $a1 str_lui
   jal strcmp
   li $s7 0xf
   bne $v0 $0 asm_universal6 
   
   move $a0 $s0			# verifico si es la instruccion li
   la $a1 str_li
   jal strcmp
   li $s7 0x08
   bne $v0 $0 asm_universali2 

   move $a0 $s0			# verifico si es la instruccion lw
   la $a1 str_lw
   jal strcmp
   li $s7 0x23
   bne $v0 $0 asm_universal9

   move $a0 $s0			# verifico si es la instruccion sw
   la $a1 str_sw
   jal strcmp
   li $s7 0x2b
   bne $v0 $0 asm_universal9

   move $a0 $s0			# verifico si es la instruccion syscall
   la $a1 str_syscall
   jal strcmp
   bne $v0 $0 asm_syscall

   move $a0 $s0			# verifico si es un label
   jal asm_label_check
   bne $v0 $0 asm_label

   j asm_error			# si no es ninguna me voy a error

###########################################
######### asm_label #######################
###########################################
asm_label:			# codigo a ejecutarse en caso que sea un label
   lb $t0 0($s0)		# se utiliza para llenar la tabla de simbolos
   addi $s0 $s0 1
   bne $t0 $s5 asm_label
   j asm_text_loop
###########################################
######### asm_syscall #####################
###########################################
asm_syscall:			# esta instruccion es muy facil de codificar ;)
   la $t0 0x0000000c
   sw $t0 0($s1)
   addi $s1 $s1 4
   j asm_text_loop
###########################################
######### asm_universal ###################
###########################################
asm_universal:
 
   srl $s6 $s7 6	# shift porque son 6bits del operador 
   addi $s0 $s0 1	# elimino el espacio
   jal asm_regs         # me devuelve el numero del registro
   add $s6 $s6 $v0	# almaceno el numero del registro en rd 
   addi $s0 $s0 1	# elimino el espacio
   jal asm_regs         # me devuelve el numero del registro
   sll $v0 $v0 10	# pongo rs en la posicion que debe ir porque falta rt (van cruzados)
   or  $s6 $s6 $v0	# almaceno el numero del registro en rs
   addi $s0 $s0 1	# elimino el espacio
   jal asm_regs         # me devuelve el numero del registro
   sll $v0 $v0 5	# pongo rt en la posicion de enmedio
   or $s6 $s6 $v0       # pongo todos los registros 5b rt + 5b rs + 5rd
   sll $s6 $s6 11	# le hago shift de 11 para hacer espacio al op. Code
   or $s6 $s6 $s7
   sw $s6 0($s1)	# almaceno la instruccion codificada
   addi $s1 $s1 4
   j asm_text_loop
###########################################
######### asm_universal2###################
###########################################
asm_universal2:    
   srl $s6 $s7 6	# shift porque son 6bits del operador 
   addi $s0 $s0 1	# elimino el espacio
   jal asm_regs         # me devuelve el numero del registro
   sll $v0 $v0 5
   or $s6 $s6 $v0	# almaceno el numero del registro en rd 
   addi $s0 $s0 1	# elimino el espacio
   jal asm_regs         # me devuelve el numero del registro                	# pongo rs en la posicion que debe ir porque falta rt (van cruzados)
   or  $s6 $s6 $v0	# almaceno el numero del registro en rs
   sll $s6 $s6 16	# le hago shift de 16 para hacer espacio al op. Code
   or $s6 $s6 $s7
   sw $s6 0($s1)	# almaceno la instruccion codificada
   addi $s1 $s1 4
   j asm_text_loop
###########################################
######### asm_universal3 ###################
###########################################
asm_universal3:      

   srl $s6 $s7 6	# shift porque son 6bits del operador 
   addi $s0 $s0 1	# elimino el espacio
   jal asm_regs         # me devuelve el numero del registro
   add $s6 $s6 $v0	# almaceno el numero del registro en rd 
   addi $s0 $s0 1	# elimino el espacio
   jal asm_regs         # me devuelve el numero del registro
   sll $v0 $v0 5	# pongo rs en la posicion que debe ir porque falta rt (van cruzados)
   or  $s6 $s6 $v0	# almaceno el numero del registro en rs
   addi $s0 $s0 1	# elimino el espacio
   jal asm_regs         # me devuelve el numero del registro
   sll $v0 $v0 10	# pongo rt en la posicion de enmedio
   or $s6 $s6 $v0       # pongo todos los registros 5b rt + 5b rs + 5rd
   sll $s6 $s6 11	# le hago shift de 11 para hacer espacio al op. Code
   or $s6 $s6 $s7
   sw $s6 0($s1)	# almaceno la instruccion codificada
   addi $s1 $s1 4
   j asm_text_loop
###########################################
######### asm_universal4 ###################
###########################################
asm_universal4:      

   srl $s6 $s7 6	# shift porque son 6bits del operador 
   addi $s0 $s0 1	# elimino el espacio
   jal asm_regs         # me devuelve el numero del registro
   add $s6 $s6 $v0  	# almaceno el numero del registro en rd 
   addi $s0 $s0 1	# elimino el espacio
   jal asm_regs         # me devuelve el numero del registro
   sll $v0 $v0 5        #intercambio la posicion de rt y rd
   or  $s6 $s6 $v0	# almaceno el numero del registro en rs
   sll $s6 $s6 11       #espacio para el shift y el op.code
   addi $s0 $s0 1
   jal ascii_to_int  	# hago la conversion de ascii a int
   sll $v0 $v0 6
   addu $s6 $s6 $v0 	# concateno el imm con el resto que ya tenia
   or $s6 $s6 $s7
   sw $s6 0($s1)	# almaceno la instruccion codificada
   addi $s1 $s1 4
   j asm_text_loop
###########################################
######### asm_universal5 ##################
###########################################
asm_universal5:       
   srl $s6 $s7 6	# shift porque son 6bits del operador 
   addi $s0 $s0 1	# elimino el espacio
   jal asm_regs         # me devuelve el numero del registro
   add $s6 $s6 $v0	# almaceno el numero del registro en rd 
   sll $s6 $s6 11	# le hago shift de 11 para hacer espacio al op. Code
   or $s6 $s6 $s7
    sw $s6 0($s1)	# almaceno la instruccion codificada
   addi $s1 $s1 4
   j asm_text_loop
###########################################
######### asm_universal6 ##################
###########################################
asm_universal6:       
   sll $s7 $s7 10	# shift porque son bits del 5b de rs 
   addi $s0 $s0 1	# elimino el espacio
   jal asm_regs         # me devuelve el numero del registro
   add $s7 $s7 $v0	# almaceno el numero del registro en rd 
   sll $s7 $s7 16	# le hago shift de 11 para hacer espacio al op. Code
   addi $s0 $s0 1       # elimino el espcio
   jal ascii_to_int     # hago la conversion de ascii a int
   addu $s7 $s7 $v0     # concateno el imm con el resto que ya tenia
   sw $s7 0($s1)	# almaceno la instruccion codificada
   addi $s1 $s1 4
   j asm_text_loop
###########################################
######### asm_universal7 #################
###########################################
asm_universal7:
   srl $s6 $s7 6        # shift del op.code para dejarlo en cero en $s6
   addi $s0 $s0 1	# elimino el espacio
   jal asm_regs         # me devuelve el numero del registro
   add $s6 $s6 $v0      # ingreso el primer registro rs
   addi $s0 $s0 1	# elimino el espacio
   jal asm_regs         # me devuelve el numero del registro
   sll $v0 $v0 10       # 
   add $s6 $s6 $v0	# almaceno el numero del registro en rs
   sll $s6 $s6 11	# le hago shift de 11 para 5b del shift y 6 del op.code
   add $s6 $s6 $s7
   sw $s6 0($s1)	# almaceno la instruccion codificada
   addi $s1 $s1 4
   j asm_text_loop
###########################################
######### asm_universal8###################
###########################################
asm_universal8:    
   srl $s6 $s7 6	# shift porque son 6bits del operador 
   addi $s0 $s0 1
   jal asm_regs
   add $s3 $v0 $0
   addi $s0 $s0 1	# elimino el espacio
   jal asm_regs         # me devuelve el numero del registro
   sll $v0 $v0 5
   or $s6 $s6 $v0	# almaceno el numero del registro en rd 
   addi $s0 $s0 1	# elimino el espacio
   jal asm_regs         # me devuelve el numero del registro                	
   or  $s6 $s6 $v0	# almaceno el numero del registro en rs
   sll $s6 $s6 16	# le hago shift de 16 para hacer espacio al op. Code
   or $s6 $s6 $s7
   sw $s6 0($s1)	# almaceno la instruccion codificada
   addi $s1 $s1 4   
   li $s7 0x12          
   srl $s6 $s7 6        # shift porque son 6 bits del operador
   add $s6 $s6 $s3      # guardo el registro en la cadena
   sll $s6 $s6 11       # hago el espacio para el op.code
   or $s6 $s6 $s7       # concateno toda la instruccion
   sw $s6 0($s1)        # almaceno la instruccion codificada
   addi $s1 $s1 4
   j asm_text_loop

###########################################
######### asm_universal9 ##################
###########################################
asm_universal9:       
   sll $s7 $s7 10	# shift porque son bits del 5b de rs y 5b de rt 
   addi $s0 $s0 1	# elimino el espacio
   jal asm_regs         # me devuelve el numero del registro
   add $s7 $s7 $v0	# almaceno el numero del registro en rt  
   sll $s7 $s7 	16      # le hago shift de 16 para hacer el offset
   addi $s0 $s0 1       # elimino el espcio
   jal ascii_to_int     # hago la conversion de ascii a int
   addu $s7 $s7 $v0     # concateno el imm con el resto que ya tenia
   addi $s0 $s0 1       # corro el espacio del parentesis
   jal asm_regs         # jalo el registro rs 
   sll $v0 $v0 21       # lo dejo en la posicion deseada
   or $s7 $s7 $v0       #lo concateno 
   sw $s7 0($s1)	# almaceno la instruccion codificada
   addi $s1 $s1 4
   j asm_text_loop
###########################################
######### asm_universali ##################
###########################################
asm_universali:
   sll $s7 $s7 10	# shift porque son 5b de rt + 5b de rs
   addi $s0 $s0 1	# elimino el espacio
   jal asm_regs         # me devuelve el numero del registro
   add $s7 $s7 $v0	# almaceno el numero del registro en rs
   addi $s0 $s0 1	# elimino el espacio
   jal asm_regs         # me devuelve el numero del registro
   sll $v0 $v0 5	# pongo rs en la posicion que debe ir (van cruzados)
   or  $s7 $s7 $v0	# almaceno el numero del registro en rt
   sll $s7 $s7 16	# le hago shift de 16 para hacer espacio al imm
   addi $s0 $s0 1	# elimino el espacio
   jal ascii_to_int	# hago la conversion de ascii a int
   addu $s7 $s7 $v0 	# concateno el imm con el resto que ya tenia
   sw $s7 0($s1)	# almaceno la instruccion codificada
   addi $s1 $s1 4
   j asm_text_loop
###########################################
######### asm_universali2 #################
###########################################
asm_universali2:
   sll $s7 $s7 10	# shift porque son 5b de rt + 5b de rs
   addi $s0 $s0 1	# elimino el espacio
   jal asm_regs         # me devuelve el numero del registro
   add $s7 $s7 $v0	# almaceno el numero del registro en rs
   sll $s7 $s7 16	# le hago shift de 16 para hacer espacio al imm
   addi $s0 $s0 1	# elimino el espacio
   jal ascii_to_int	# hago la conversion de ascii a int
   addu $s7 $s7 $v0 	# concateno el imm con el resto que ya tenia
   sw $s7 0($s1)	# almaceno la instruccion codificada
   addi $s1 $s1 4
   j asm_text_loop
###########################################
#########  asm_verificar  #################
###########################################
asm_verificar: 
addi $s0 $s0 9               #carga $s1 3
beq $s0 '\n'  asm_universal2 #si en la posicon tres es \n    
j asm_universal8             #ejecuta la pseudo intruccion de div           
   
###########################################
############# asm_regs ####################
###########################################
asm_regs:		# pasa de $AN -> N ej. $s0 -> 16
   addi $sp $sp -4	# por supuesto que esta incompleto...
   sw $ra 0($sp)
   li $t7 '$'		# voy a utilizarlo para verificar que viene un registro
   li $t6 'a'		# aX -> argumentos
   li $t5 'v'		# vX -> valores de retorno
   li $t4 '0'		# cero
   li $t3 't'           # tx -> temporales
   li $t8 's'           # sx -> save  
  
   lb $t0 0($s0)
   addi $s0 $s0 1
   bne $t0 $t7 asm_error	# si no empieza con $ no es valido
   lb $t0 0($s0)
   addi $s0 $s0 1
   beq $t0 $t6 asm_regs_ax	# verifico a que grupo pertence para sumarle un offset
   beq $t0 $t5 asm_regs_vx
   beq $t0 $t4 asm_regs_zero
   beq $t0 $t3 asm_regs_tx
   beq $t0 $t8 asm_regs_sx
   j asm_error			# no es ninguno... error

asm_regs_zero:		# caso trivial 
   li $v0 0
   j asm_regs_exit

asm_regs_ax:		# le pongo de base $a0 y sumo su offset
   jal ascii_to_int	# ($a0 = 4) => ($a3 - $a0) + 4 = 7
   addi $v0 $v0 4
   j asm_regs_exit

asm_regs_vx:
   jal ascii_to_int
   addi $v0 $v0 2
   j asm_regs_exit

asm_regs_tx:
   jal ascii_to_int
   addi $v0 $v0 8
   j asm_regs_exit

asm_regs_sx:
jal ascii_to_int
   addi $v0 $v0 16
   j asm_regs_exit

asm_regs_exit:
   lw $ra 0($sp)
   addi $sp $sp 4
   jr $ra


###########################################
######### ascii_to_int ####################
###########################################
ascii_to_int:		# la famosa funcion atoi
li $t1 0		# sin verificaciones
li $t2 ' '
li $t3 '\n'
li $t4 10
li $t6 '-'
li $t7 '('
li $v0 0

ascii_to_int_loop:
   lb $t0 0($s0)
   beq $t0 $t6 negative
   beq $t0 $t7 ascii_to_int_exit
   beq $t0 $0  ascii_to_int_exit
   beq $t0 $t2 ascii_to_int_exit
   beq $t0 $t3 ascii_to_int_exit
   addi $s0 $s0 1
   addi $t0 $t0 -48
   mul  $v0 $v0 $t4
   add  $v0 $v0 $t0
   j ascii_to_int_loop
   
negative:
addi $s5 $0 1
addi $s0 $s0 1
j ascii_to_int_loop

ascii_to_int_exit:
bne $s5 1 nega
sub $v0 $0 $t0
jr $ra

nega:
jr $ra

###########################################
######### strcmp ##########################
###########################################

strcmp:			# compara 2 cadenas de caracteres
   li $t2 ' '
   li $t3 '\n'
   li $t4 '\t'
   li $t5 '#'

strcmp_loop:
   lb $t0 0($a0)
   lb $t1 0($a1)
   beq $t0 $t2 strcmp_maybe
   beq $t0 $t3 strcmp_maybe
   beq $t0 $t4 strcmp_maybe
   beq $t0 $t5 strcmp_maybe
   beq $t0 $0  strcmp_maybe
   bne $t0 $t1 strcmp_false
   addi $a0 $a0 1
   addi $a1 $a1 1
   j strcmp_loop
   
strcmp_maybe:
   beq $t1 $0 strcmp_true
   j strcmp_false

strcmp_true:
   move $s0 $a0	
   li $v0 1
   jr $ra

strcmp_false:
   li $v0 0
   jr $ra
###########################################
######### asm_label_check #################
###########################################
asm_label_check:	# verifica si la cadena es un label
   li $t1 ':'
   li $t2 ' '
   li $t3 '\n'

asm_label_loop:
   lb $t0 0($a0)
   addi $a0 $a0 1
   beq $t0 $t1 asm_label_true
   beq $t0 $t2 asm_label_false
   beq $t0 $t3 asm_label_false
   j asm_label_loop

asm_label_true:
   move $s0 $a0
   li $v0 1
   jr $ra

asm_label_false:
   li $v0 0
   jr $ra